'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('../icon/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _lodash = require('lodash');

var _Core = require('./Core.js');

var _Core2 = _interopRequireDefault(_Core);

var _events = require('./events');

var _events2 = _interopRequireDefault(_events);

require('./ImgsPreview.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ImgsPreview = (_temp = _class = function (_React$Component) {
	(0, _inherits3.default)(ImgsPreview, _React$Component);

	function ImgsPreview() {
		var _ref;

		(0, _classCallCheck3.default)(this, ImgsPreview);

		for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
			params[_key] = arguments[_key];
		}

		var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = ImgsPreview.__proto__ || Object.getPrototypeOf(ImgsPreview)).call.apply(_ref, [this].concat(params)));

		_this.setRef = function (node, index) {};

		_this.handleShow = function (e, index) {
			var pos = {};

			try {
				var target = e.target; // 先得到pos, 否则getThumbBoundsFn再计算，target已变化
				var pageYScroll = window.pageYOffset || document.documentElement.scrollTop;
				var rect = target.getBoundingClientRect();

				pos = { x: rect.left, y: rect.top + pageYScroll, w: rect.width };
			} catch (e) {
				console.log(e);
			}

			var opts = _this.state.opts;

			opts.index = index;
			opts.getThumbBoundsFn = function (index) {
				return pos;
			};

			_this.setState({
				show: true,
				opts: opts
			});
		};

		_this.handleClose = function () {
			_this.setState({
				show: false
			});
			_this.props.onClose && _this.props.onClose();
		};

		_this.state = {
			show: _this.props.show,
			opts: _this.props.opts
		};

		_this.imgs = [];
		return _this;
	} // 兼容0.4.38前版本


	(0, _createClass3.default)(ImgsPreview, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			var show = this.state.show;

			if (nextProps.show) {
				if (!show) {
					this.setState({ show: true });
				}
			} else if (show) {
				this.setState({ show: false });
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    dataSource = _props.dataSource,
			    renderRow = _props.renderRow,
			    style = _props.style,
			    className = _props.className,
			    portal = _props.portal,
			    id = _props.id,
			    other = (0, _objectWithoutProperties3.default)(_props, ['dataSource', 'renderRow', 'style', 'className', 'portal', 'id']);
			var _state = this.state,
			    show = _state.show,
			    opts = _state.opts;

			var Target = portal ? _Core2.default.Portal : _Core2.default;
			return _react2.default.createElement(
				_react.Fragment,
				null,
				_react2.default.createElement(
					'div',
					{
						className: (0, _classnames2.default)(['rc-imgs-preview', className]).trim(),
						style: (0, _extends3.default)({ display: 'flex', flexWrap: 'wrap' }, style)
					},
					dataSource.map(function (item, index) {
						return _react2.default.createElement(
							'div',
							{
								key: index,
								ref: _this2.inputRef,
								className: '__item'
								// onClick={(e) => (this.handleShow(e, index))}
							},
							renderRow(item, index),
							_react2.default.createElement(
								'div',
								{ className: '__mask' },
								_react2.default.createElement(_Icon2.default, {
									type: 'search',
									style: { fontSize: 20 },
									onClick: function onClick(e) {
										return _this2.handleShow(e, index);
									}
								})
							)
						);
					})
				),
				_react2.default.createElement(Target, (0, _extends3.default)({
					ref: 'core',
					id: id
				}, (0, _lodash.pick)(other, _events2.default), {
					setInstance: function setInstance(instance) {
						return _this2.instance = instance;
					},
					show: show,
					dataSource: dataSource,
					opts: opts,
					onClose: this.handleClose
				}))
			);
		}
	}]);
	return ImgsPreview;
}(_react2.default.Component), _class.Core = _Core2.default, _class.Portal = _Core2.default.Portal, _class.Func = _Core2.default.Func, _class.popup = _Core2.default.Func.popup, _temp);


ImgsPreview.propTypes = {
	dataSource: _propTypes2.default.array.isRequired,
	opts: _propTypes2.default.object,
	renderRow: _propTypes2.default.func,
	id: _propTypes2.default.string,
	className: _propTypes2.default.string,
	show: _propTypes2.default.bool,
	onClose: _propTypes2.default.func
};

ImgsPreview.defaultProps = {
	opts: {
		history: false // 关闭url
	},
	renderRow: function renderRow(item, index) {
		var image = (typeof item === 'undefined' ? 'undefined' : (0, _typeof3.default)(item)) === 'object' ? item.thumbnail || item.msrc || item.src : item;
		return _react2.default.createElement('img', {
			src: image,
			width: '100',
			height: '100',
			'data-index': index
		});
	},
	className: '',
	show: false,
	onClose: function onClose() {}
};

exports.default = ImgsPreview;