'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _Icon = require('../icon/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Item = require('./Item');

var _Item2 = _interopRequireDefault(_Item);

require('./Styles.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NavBar = (_temp = _class = function (_Component) {
	(0, _inherits3.default)(NavBar, _Component);

	function NavBar(props) {
		(0, _classCallCheck3.default)(this, NavBar);

		var _this = (0, _possibleConstructorReturn3.default)(this, (NavBar.__proto__ || Object.getPrototypeOf(NavBar)).call(this, props));

		_this.componentWillUnmount = function () {
			window.removeEventListener('resize', _this.handleResizeWindow);
		};

		_this.setMaxDistance = function (scrollWidth, moveDis) {
			_this.maxDis = scrollWidth < moveDis ? 0 : scrollWidth - moveDis;
		};

		_this.handleResizeWindow = function () {
			_this.moveDis = _this.scroll.current.clientWidth;
			_this.handleToggleOPt();
			_this.setMaxDistance(_this.scrollWidth, _this.moveDis);

			if (_this.state.translateX > _this.maxDis) {
				_this.setState({
					translateX: _this.maxDis
				});
			} else {
				_this.handleIntoView();
			}
		};

		_this.handleToggleOPt = function () {
			_this.setState({
				showOpt: _this.moveDis < _this.scrollWidth
			}, function () {
				_this.moveDis = _this.scroll.current.clientWidth;
			});
		};

		_this.handleIntoView = function () {
			var itemOffset = _this.props.itemOffset;

			var newArr = [].concat((0, _toConsumableArray3.default)(_this.navs));
			newArr.length = _this.activeIndex + 1;
			var leftDis = newArr.reduce(function (prev, cur) {
				return prev + cur;
			});
			var prevLeft = leftDis - newArr[_this.activeIndex];
			var offset = _this.navs.length - 1 == _this.activeIndex ? 0 : itemOffset;

			if (leftDis > _this.moveDis) {
				if (leftDis - _this.state.translateX > _this.moveDis) {
					_this.setState({
						translateX: leftDis - _this.moveDis - offset
					});
				} else if (prevLeft < _this.state.translateX) {
					_this.setState({
						translateX: prevLeft
					});
				}
			} else {
				_this.setState({
					translateX: 0
				});
			}
		};

		_this.handlePushNav = function (nav) {
			_this.navs.push(nav);
		};

		_this.handlePrev = function () {
			var translateX = _this.state.translateX;

			_this.setState({
				translateX: translateX - _this.moveDis < _this.minDis ? 0 : translateX - _this.moveDis
			});
		};

		_this.handleNext = function () {
			var translateX = _this.state.translateX;

			_this.setState({
				translateX: Math.min(translateX + _this.moveDis, _this.maxDis)
			});
		};

		_this.state = {
			translateX: 0,
			showOpt: false // 是否显示左右操作箭头
		};
		_this.minDis = 0; // 最小可移动距离
		_this.maxDis = 0; // 最大可移动距离
		_this.moveDis = 0; // 点击<、>的移动距离, 即滚动容器的宽度
		_this.scrollWidth = 0; // nav的总长度
		_this.navs = []; // navItem的长度数组
		_this.scroll = _react2.default.createRef(); // 滚动容器
		_this.activeIndex = 0; // 选中的nav的数组索引（index）

		// throttle resize节流
		_this.handleResizeWindow = (0, _lodash.throttle)(_this.handleResizeWindow, 300);
		return _this;
	}

	(0, _createClass3.default)(NavBar, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this2 = this;

			this.scrollWidth = this.navs.reduce(function (prev, cur) {
				return prev + cur;
			});
			setTimeout(function () {
				// 因为左右两侧箭头显示隐藏的关系，因为走的是state所以会导致 moveDis 的值有偏差
				// 所以在setTimeout中执行setState，这样state更新就是同步的了
				_this2.moveDis = _this2.scroll.current.clientWidth;
				_this2.handleToggleOPt();
				_this2.setMaxDistance(_this2.scrollWidth, _this2.moveDis);

				_this2.handleIntoView();
			}, 0);
			// 监听window.resize
			window.addEventListener('resize', this.handleResizeWindow);
		}
	}, {
		key: 'componentDidUpdate',
		value: function componentDidUpdate(prevProps, prevState) {
			if (prevProps.activeKey != this.props.activeKey) {
				this.handleIntoView();
			}
		}

		// window resize会导致maxDistance改变


		// 显示隐藏 左右箭头


		/**
   * 将nav item移动到视图当中，靠右
   */

	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _props = this.props,
			    children = _props.children,
			    activeKey = _props.activeKey,
			    itemOffset = _props.itemOffset,
			    onChange = _props.onChange;
			var _state = this.state,
			    translateX = _state.translateX,
			    showOpt = _state.showOpt;

			var prev = translateX == 0 ? 'hide' : 'show';
			var next = translateX == this.maxDis ? 'hide' : 'show';
			var opacity = showOpt ? '_opacity-show' : '_opacity-hide';
			var disabled = { pointerEvents: "auto", cursor: "not-allowed" };

			return _react2.default.createElement(
				'div',
				{ className: 'rc-nav-bar-container', style: { padding: '' + (showOpt ? '0 32px' : '0 0') } },
				_react2.default.createElement(
					'div',
					{ ref: this.scroll, className: '_scroll-container' },
					_react2.default.createElement(
						'div',
						{
							className: '_scroll-wrap',
							style: { transform: 'translate3d(-' + translateX + 'px, 0, 0)' }
						},
						_react2.default.createElement(
							'div',
							null,
							_react2.default.Children.map(children, function (child, index) {
								if (!child) return null;
								if (activeKey == child.key) {
									_this3.activeIndex = index;
								}

								return _react2.default.cloneElement(child, (0, _extends3.default)({}, child.props, {
									active: activeKey == child.key, // 以该组件判断的为主, 覆盖外部传入的值
									isEnd: children.length - 1 == index,
									offset: itemOffset,
									onPushNav: _this3.handlePushNav,
									onClick: function onClick() {
										return onChange && onChange(child.key);
									}
								}));
							})
						)
					)
				),
				_react2.default.createElement(
					'span',
					{
						unselectable: 'unselectable',
						className: '_flex-cc _nav-prev _nav-prev-' + prev + ' ' + opacity,
						style: (0, _extends3.default)({}, prev === 'hide' ? disabled : {}, { width: showOpt ? 32 : 0 }),
						onClick: this.handlePrev
					},
					_react2.default.createElement(_Icon2.default, { type: 'left' })
				),
				_react2.default.createElement(
					'span',
					{
						unselectable: 'unselectable',
						className: '_flex-cc _nav-next _nav-next-' + next + ' ' + opacity,
						style: (0, _extends3.default)({}, next === 'hide' ? disabled : {}, { width: showOpt ? 32 : 0 }),
						onClick: this.handleNext
					},
					_react2.default.createElement(_Icon2.default, { type: 'right' })
				)
			);
		}
	}]);
	return NavBar;
}(_react.Component), _class.Item = _Item2.default, _temp);


NavBar.propTypes = {
	itemOffset: _propTypes2.default.number
};

NavBar.defaultProps = {
	itemOffset: 32
};

exports.default = NavBar;